@rem
@rem Copyright 2015 the original author or authors.
@rem
@rem Licensed under the Apache License, Version 2.0 (the "License");
@rem you may not use this file except in compliance with the License.
@rem You may obtain a copy of the License at
@rem
@rem      https://www.apache.org/licenses/LICENSE-2.0
@rem
@rem Unless required by applicable law or agreed to in writing, software
@rem distributed under the License is distributed on an "AS IS" BASIS,
@rem WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
@rem See the License for the specific language governing permissions and
@rem limitations under the License.
@rem
@rem SPDX-License-Identifier: Apache-2.0
@rem

@if "%DEBUG%"=="" @echo off
@rem ##########################################################################
@rem
@rem  aerospike-vector-search startup script for Windows
@rem
@rem ##########################################################################

@rem Set local scope for the variables with windows NT shell
if "%OS%"=="Windows_NT" setlocal

set DIRNAME=%~dp0
if "%DIRNAME%"=="" set DIRNAME=.
@rem This is normally unused
set APP_BASE_NAME=%~n0
set APP_HOME=%DIRNAME%..

@rem Resolve any "." and ".." in APP_HOME to make it shorter.
for %%i in ("%APP_HOME%") do set APP_HOME=%%~fi

@rem Add default JVM options here. You can also use JAVA_OPTS and AEROSPIKE_VECTOR_SEARCH_OPTS to pass JVM options to this script.
set DEFAULT_JVM_OPTS="-Djava.security.egd=file:/dev/./urandom" "-Dconnect.product.name=aerospike-vector-search" "-Dconnect.product.version=0.11.1" "-XX:+ExitOnOutOfMemoryError" "-XX:+UseZGC" "-XX:+ZGenerational" "-XX:+AlwaysPreTouch" "--add-modules" "jdk.incubator.vector" "--add-opens" "java.base/jdk.internal.util=ALL-UNNAMED"

@rem Find java.exe
if defined JAVA_HOME goto findJavaFromJavaHome

set JAVA_EXE=java.exe
%JAVA_EXE% -version >NUL 2>&1
if %ERRORLEVEL% equ 0 goto execute

echo. 1>&2
echo ERROR: JAVA_HOME is not set and no 'java' command could be found in your PATH. 1>&2
echo. 1>&2
echo Please set the JAVA_HOME variable in your environment to match the 1>&2
echo location of your Java installation. 1>&2

goto fail

:findJavaFromJavaHome
set JAVA_HOME=%JAVA_HOME:"=%
set JAVA_EXE=%JAVA_HOME%/bin/java.exe

if exist "%JAVA_EXE%" goto execute

echo. 1>&2
echo ERROR: JAVA_HOME is set to an invalid directory: %JAVA_HOME% 1>&2
echo. 1>&2
echo Please set the JAVA_HOME variable in your environment to match the 1>&2
echo location of your Java installation. 1>&2

goto fail

:execute
@rem Setup the command line

set CLASSPATH=%APP_HOME%\lib\aerospike-vector-search-0.11.1.jar;%APP_HOME%\lib\aerospike-vector-search-transact-0.11.0.jar;%APP_HOME%\lib\aerospike-vector-search-clustering-0.11.0.jar;%APP_HOME%\lib\aerospike-vector-search-index-0.11.0.jar;%APP_HOME%\lib\aerospike-vector-search-security-0.11.0.jar;%APP_HOME%\lib\aerospike-vector-search-cluster-common-0.11.0.jar;%APP_HOME%\lib\aerospike-vector-search-storage-aerospike-0.11.1.jar;%APP_HOME%\lib\aerospike-vector-search-embedded-client-0.11.0.jar;%APP_HOME%\lib\aerospike-vector-search-common-0.11.0.jar;%APP_HOME%\lib\aerospike-manage-1.0.12.jar;%APP_HOME%\lib\aerospike-aerospike-2.2.9.jar;%APP_HOME%\lib\aerospike-tls-1.2.10.jar;%APP_HOME%\lib\aerospike-vector-search-licensing-0.11.0.jar;%APP_HOME%\lib\aerospike-vector-search-server-stub-0.11.0.jar;%APP_HOME%\lib\aerospike-metrics-1.0.7.jar;%APP_HOME%\lib\aerospike-serde-1.1.10.jar;%APP_HOME%\lib\aerospike-io-1.0.10.jar;%APP_HOME%\lib\aerospike-logging-1.2.5.jar;%APP_HOME%\lib\aerospike-undertow-patch-2.3.15.jar;%APP_HOME%\lib\guice-assistedinject-6.0.0.jar;%APP_HOME%\lib\guice-bridge-3.0.4.jar;%APP_HOME%\lib\guice-servlet-6.0.0.jar;%APP_HOME%\lib\guice-6.0.0.jar;%APP_HOME%\lib\validation-api-2.0.1.Final.jar;%APP_HOME%\lib\grpc-netty-1.67.1.jar;%APP_HOME%\lib\netty-handler-proxy-4.1.113.Final.jar;%APP_HOME%\lib\netty-codec-http2-4.1.113.Final.jar;%APP_HOME%\lib\netty-transport-native-epoll-4.1.113.Final-linux-x86_64.jar;%APP_HOME%\lib\netty-transport-native-kqueue-4.1.113.Final-osx-x86_64.jar;%APP_HOME%\lib\netty-codec-socks-4.1.113.Final.jar;%APP_HOME%\lib\netty-codec-http-4.1.113.Final.jar;%APP_HOME%\lib\netty-handler-4.1.113.Final.jar;%APP_HOME%\lib\netty-codec-4.1.113.Final.jar;%APP_HOME%\lib\netty-transport-classes-epoll-4.1.113.Final.jar;%APP_HOME%\lib\netty-transport-classes-kqueue-4.1.113.Final.jar;%APP_HOME%\lib\netty-transport-native-unix-common-4.1.113.Final.jar;%APP_HOME%\lib\netty-transport-4.1.113.Final.jar;%APP_HOME%\lib\grpc-kotlin-stub-1.4.1.jar;%APP_HOME%\lib\kotlinx-coroutines-core-jvm-1.9.0.jar;%APP_HOME%\lib\java-jwt-4.4.0.jar;%APP_HOME%\lib\jackson-dataformat-yaml-2.17.0.jar;%APP_HOME%\lib\jackson-dataformat-msgpack-0.9.8.jar;%APP_HOME%\lib\jersey-media-json-jackson-3.1.5.jar;%APP_HOME%\lib\metrics-json-4.2.25.jar;%APP_HOME%\lib\jackson-module-jakarta-xmlbind-annotations-2.17.0.jar;%APP_HOME%\lib\jackson-databind-2.17.0.jar;%APP_HOME%\lib\jackson-annotations-2.17.0.jar;%APP_HOME%\lib\jackson-core-2.17.0.jar;%APP_HOME%\lib\jackson-module-kotlin-2.17.0.jar;%APP_HOME%\lib\kotlin-reflect-2.0.21.jar;%APP_HOME%\lib\kotlin-stdlib-jdk7-2.0.21.jar;%APP_HOME%\lib\protobuf-kotlin-3.25.5.jar;%APP_HOME%\lib\kotlin-logging-jvm-3.0.5.jar;%APP_HOME%\lib\kotlin-stdlib-2.0.21.jar;%APP_HOME%\lib\kotlin-stdlib-jdk8-2.0.21.jar;%APP_HOME%\lib\grpc-util-1.67.1.jar;%APP_HOME%\lib\grpc-core-1.67.1.jar;%APP_HOME%\lib\protobuf-java-util-3.25.5.jar;%APP_HOME%\lib\dsiutils-2.7.3.jar;%APP_HOME%\lib\grpc-context-1.67.1.jar;%APP_HOME%\lib\grpc-protobuf-1.67.1.jar;%APP_HOME%\lib\grpc-stub-1.67.1.jar;%APP_HOME%\lib\grpc-protobuf-lite-1.67.1.jar;%APP_HOME%\lib\grpc-api-1.67.1.jar;%APP_HOME%\lib\guava-33.3.0-jre.jar;%APP_HOME%\lib\perfmark-api-0.27.0.jar;%APP_HOME%\lib\picocli-4.7.6.jar;%APP_HOME%\lib\caffeine-3.1.8.jar;%APP_HOME%\lib\bcpkix-jdk18on-1.78.1.jar;%APP_HOME%\lib\bcutil-jdk18on-1.78.1.jar;%APP_HOME%\lib\bcprov-jdk18on-1.78.1.jar;%APP_HOME%\lib\lombok-1.18.30.jar;%APP_HOME%\lib\commons-lang3-3.13.0.jar;%APP_HOME%\lib\commons-collections4-4.4.jar;%APP_HOME%\lib\jul-to-slf4j-1.7.36.jar;%APP_HOME%\lib\logback-json-classic-0.1.5.jar;%APP_HOME%\lib\logback-classic-1.5.0.jar;%APP_HOME%\lib\cron-utils-9.2.1.jar;%APP_HOME%\lib\reflections-0.10.2.jar;%APP_HOME%\lib\metrics-jvm-4.2.25.jar;%APP_HOME%\lib\metrics-core-4.2.25.jar;%APP_HOME%\lib\slf4j-api-2.0.12.jar;%APP_HOME%\lib\logback-jackson-0.1.5.jar;%APP_HOME%\lib\logback-json-core-0.1.5.jar;%APP_HOME%\lib\logback-core-1.5.0.jar;%APP_HOME%\lib\javax.inject-1.jar;%APP_HOME%\lib\jersey-container-servlet-core-3.1.5.jar;%APP_HOME%\lib\jersey-server-3.1.5.jar;%APP_HOME%\lib\jersey-hk2-3.1.5.jar;%APP_HOME%\lib\jersey-media-multipart-3.1.5.jar;%APP_HOME%\lib\jersey-client-3.1.5.jar;%APP_HOME%\lib\jersey-common-3.1.5.jar;%APP_HOME%\lib\hk2-locator-3.0.5.jar;%APP_HOME%\lib\hk2-api-3.0.5.jar;%APP_HOME%\lib\hk2-utils-3.0.5.jar;%APP_HOME%\lib\jakarta.inject-api-2.0.1.jar;%APP_HOME%\lib\aopalliance-1.0.jar;%APP_HOME%\lib\mbassador-1.3.2.jar;%APP_HOME%\lib\vault-java-driver-5.1.0.jar;%APP_HOME%\lib\aerospike-client-jdk21-8.1.4.jar;%APP_HOME%\lib\commons-math3-3.6.1.jar;%APP_HOME%\lib\jbcrypt-0.4.jar;%APP_HOME%\lib\gson-2.11.0.jar;%APP_HOME%\lib\error_prone_annotations-2.28.0.jar;%APP_HOME%\lib\netty-buffer-4.1.113.Final.jar;%APP_HOME%\lib\netty-resolver-4.1.113.Final.jar;%APP_HOME%\lib\netty-common-4.1.113.Final.jar;%APP_HOME%\lib\failureaccess-1.0.2.jar;%APP_HOME%\lib\listenablefuture-9999.0-empty-to-avoid-conflict-with-guava.jar;%APP_HOME%\lib\jsr305-3.0.2.jar;%APP_HOME%\lib\checker-qual-3.43.0.jar;%APP_HOME%\lib\annotations-4.1.1.4.jar;%APP_HOME%\lib\animal-sniffer-annotations-1.24.jar;%APP_HOME%\lib\annotations-23.0.0.jar;%APP_HOME%\lib\proto-google-common-protos-2.41.0.jar;%APP_HOME%\lib\protobuf-java-3.25.5.jar;%APP_HOME%\lib\simpleclient_dropwizard-0.16.0.jar;%APP_HOME%\lib\simpleclient_servlet-0.16.0.jar;%APP_HOME%\lib\undertow-servlet-2.3.15.Final.jar;%APP_HOME%\lib\gnu-crypto-2.0.1.jar;%APP_HOME%\lib\luaj-jse-3.0.1.jar;%APP_HOME%\lib\aerospike-connect-outbound-sdk-2.2.0.jar;%APP_HOME%\lib\commons-io-2.15.1.jar;%APP_HOME%\lib\j2objc-annotations-2.8.jar;%APP_HOME%\lib\fastutil-8.5.12.jar;%APP_HOME%\lib\jsap-20210129.jar;%APP_HOME%\lib\byte-buddy-1.14.9.jar;%APP_HOME%\lib\snakeyaml-2.2.jar;%APP_HOME%\lib\msgpack-core-0.9.8.jar;%APP_HOME%\lib\javax.annotation-api-1.3.2.jar;%APP_HOME%\lib\simpleclient_servlet_common-0.16.0.jar;%APP_HOME%\lib\simpleclient_common-0.16.0.jar;%APP_HOME%\lib\simpleclient-0.16.0.jar;%APP_HOME%\lib\javassist-3.29.2-GA.jar;%APP_HOME%\lib\mimepull-1.9.15.jar;%APP_HOME%\lib\jersey-entity-filtering-3.1.5.jar;%APP_HOME%\lib\jakarta.xml.bind-api-4.0.0.jar;%APP_HOME%\lib\jakarta.servlet-api-6.0.0.jar;%APP_HOME%\lib\jakarta.annotation-api-2.1.1.jar;%APP_HOME%\lib\jakarta.ws.rs-api-3.1.0.jar;%APP_HOME%\lib\jakarta.validation-api-3.0.2.jar;%APP_HOME%\lib\xnio-nio-3.8.16.Final.jar;%APP_HOME%\lib\xnio-api-3.8.16.Final.jar;%APP_HOME%\lib\wildfly-client-config-1.0.1.Final.jar;%APP_HOME%\lib\jboss-threads-3.5.0.Final.jar;%APP_HOME%\lib\jboss-logging-3.4.3.Final.jar;%APP_HOME%\lib\wildfly-common-1.5.4.Final.jar;%APP_HOME%\lib\simpleclient_tracer_otel-0.16.0.jar;%APP_HOME%\lib\simpleclient_tracer_otel_agent-0.16.0.jar;%APP_HOME%\lib\osgi-resource-locator-1.0.3.jar;%APP_HOME%\lib\aopalliance-repackaged-3.0.5.jar;%APP_HOME%\lib\jakarta.activation-api-2.1.0.jar;%APP_HOME%\lib\simpleclient_tracer_common-0.16.0.jar


@rem Execute aerospike-vector-search
"%JAVA_EXE%" %DEFAULT_JVM_OPTS% %JAVA_OPTS% %AEROSPIKE_VECTOR_SEARCH_OPTS%  -classpath "%CLASSPATH%" com.aerospike.vector.VectorDbMainKt %*

:end
@rem End local scope for the variables with windows NT shell
if %ERRORLEVEL% equ 0 goto mainEnd

:fail
rem Set variable AEROSPIKE_VECTOR_SEARCH_EXIT_CONSOLE if you need the _script_ return code instead of
rem the _cmd.exe /c_ return code!
set EXIT_CODE=%ERRORLEVEL%
if %EXIT_CODE% equ 0 set EXIT_CODE=1
if not ""=="%AEROSPIKE_VECTOR_SEARCH_EXIT_CONSOLE%" exit %EXIT_CODE%
exit /b %EXIT_CODE%

:mainEnd
if "%OS%"=="Windows_NT" endlocal

:omega
